#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <fcntl.h>
#include <string.h>

#include <compface.h>
#include <gtk/gtk.h>

#include "faceview.h"

#define FACEBUFLEN 2048
char facebuf[FACEBUFLEN];
#define XPMBUFLEN 48*48
char xpmbuf[XPMBUFLEN];
#define XPMNAME "/var/tmp/face.xpm"
#define HEADER "X-Face: "
GtkWidget *window = NULL;

void do_exit (int code)
{
  gtk_widget_destroy (window);
  gtk_main_quit ();
}

int main(int argc, char *argv[])
{
   FILE *fp;
   int dat[3], i, j, count;
   unsigned char n, *p, *t;
   GtkWidget *vbox = NULL;
   GtkWidget *pixmapwid;
   GdkPixmap *pixmap;
   GdkBitmap *mask;
   GtkStyle *style;

   fp = stdin;
   while ( fgets(xpmbuf, XPMBUFLEN - 1, fp) != NULL )
     {
	p = xpmbuf;
	if ( ( p = strstr(xpmbuf, HEADER) ) != NULL )
	  {
	     p += strlen( HEADER );
	     strcpy(facebuf, p);
	     while ( fgets(xpmbuf, XPMBUFLEN - 1, fp) != NULL )
	       {
		  if ( ' ' == xpmbuf[0] || '\t' == xpmbuf[0] )
		    {
		       strcat(facebuf, xpmbuf);
		    }
		  else
		    {
		       break;
		    }
	       }
	  }
     }

   if ( uncompface(facebuf) != 0 )
     {
	exit (-1);
     }

   t = facebuf;
   p = xpmbuf;
   for ( count = 0 ; count < 48 ; count ++ )
     {
	sscanf(t, "%x,%x,%x,\n", &dat[0], &dat[1], &dat[2]);
	for (i = 0; i < 3; i++)
	  {
	     n = ( dat[i] & 0xff00 ) >> 8;
	     for ( j = 0 ; j < 8 ; j++ )
	       {
//		  (n & ( 0x01 << j ) ) ? (*p++ = 0x23) : (*p++ = 0x2e) ;
		  (n & ( 0x80 >> j ) ) ? (*p++ = 0x23) : (*p++ = 0x2e) ;
	       }
	     n = ( dat[i] & 0x00ff );
	     for ( j = 0 ; j < 8 ; j++ )
	       {
//		  (n & ( 0x01 << j ) ) ? (*p++ = 0x23) : (*p++ = 0x2e) ;
		  (n & ( 0x80 >> j ) ) ? (*p++ = 0x23) : (*p++ = 0x2e) ;
	       }
	  }
	t = strchr((const char *)t, '\n') + 1;
     }

   if ( (fp = fopen(XPMNAME, "w")) == NULL )
	{
	   fprintf( stderr, "/var/tmp/face.xpm failed to open.\n");
	   exit (-1);
	}

   fprintf( fp, "/* XPM */\n");
   fprintf( fp, "static char *face[] = {\n");
   fprintf( fp, "/* width height num_colors chars_per_pixel */\n");
   fprintf( fp, "\"    48    48        2            1\",\n");
   fprintf( fp, "/* colors */\n");
   fprintf( fp, "\". c #ffffff\",\n");
   fprintf( fp, "/* pixels */\n");
   fprintf( fp, "\"# c #000000\",\n");

   p = xpmbuf;
   for ( i = 0 ; i < 47 ; i++ )
     {
	fprintf( fp, "\"" );
	for ( j = 0 ; j < 48 ; j++ )
	  {
	     fputc( *p++, fp );
	  }
	fprintf( fp, "\",\n" );
     }
   fprintf( fp, "\"" );
   for ( j = 0 ; j < 48 ; j++ )
     {
	fputc( *p++, fp );
     }
   fprintf( fp, "\"\n};\n" );
   fclose(fp);

   gtk_set_locale();
   gtk_init(&argc, &argv);

   window = gtk_window_new(GTK_WINDOW_TOPLEVEL);
   gtk_signal_connect (GTK_OBJECT (window), "destroy",
		       GTK_SIGNAL_FUNC(do_exit), window);
   gtk_window_set_title(GTK_WINDOW(window), "Face View");
   gtk_widget_set_usize(GTK_WIDGET(window), 48, 48);
   gtk_window_set_policy(GTK_WINDOW(window), FALSE, FALSE, FALSE);
   gtk_widget_show(window);

   vbox = gtk_vbox_new(FALSE, 0);
   gtk_container_border_width(GTK_CONTAINER(vbox), 1);
   gtk_container_add(GTK_CONTAINER(window), vbox);
   gtk_widget_show(vbox);

   style=gtk_widget_get_style(vbox);
   pixmap = gdk_pixmap_create_from_xpm (window->window, &mask,
					&style->bg[GTK_STATE_NORMAL],
					XPMNAME);
   pixmapwid = gtk_pixmap_new (pixmap, mask);
   remove(XPMNAME);
   gtk_container_add (GTK_CONTAINER (vbox), pixmapwid);
   gtk_widget_show(pixmapwid);

   gtk_main();

   exit(0);
}
